=== modified file 'drizzled/identifier/constants/user.cc'
--- drizzled/identifier/constants/user.cc	2011-04-05 01:15:36 +0000
+++ drizzled/identifier/constants/user.cc	2011-10-19 17:58:50 +0000
@@ -46,11 +46,11 @@
 
 } /* namespace constants */
 
+static drizzled::identifier::User g_su(str_ref("SYSTEM"));
+
 const identifier::User& system_user()
 {
-  static drizzled::identifier::User _tmp("SYSTEM");
-
-  return _tmp;
+  return g_su;
 }
 
 } /* namespace identifier */

=== modified file 'drizzled/identifier/user.h'
--- drizzled/identifier/user.h	2011-06-30 11:55:04 +0000
+++ drizzled/identifier/user.h	2011-10-19 17:58:50 +0000
@@ -20,11 +20,8 @@
 
 #pragma once
 
-#include <string>
-#include <boost/shared_ptr.hpp>
 #include <drizzled/common_fwd.h>
 #include <drizzled/identifier.h>
-#include <drizzled/visibility.h>
 
 namespace drizzled {
 namespace identifier {
@@ -46,14 +43,13 @@
     MYSQL_HASH
   };
 
-  User():
+  User() :
     password_type(NONE)
   { }
 
-  User(const std::string &username_arg):
+  User(str_ref user_arg) :
     password_type(NONE),
-    _user(username_arg),
-    _address("")
+    _user(to_string(user_arg))
   { }
 
   virtual std::string getSQLPath() const

=== modified file 'drizzled/parser.cc'
--- drizzled/parser.cc	2011-10-18 12:33:04 +0000
+++ drizzled/parser.cc	2011-10-19 17:58:50 +0000
@@ -317,28 +317,21 @@
 
 void buildSchemaOption(LEX *lex, const char *key, str_ref value)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
   opt->set_name(key);
   opt->set_state(value.data(), value.size());
 }
 
-void buildSchemaDefiner(LEX *lex, const lex_string_t &value)
-{
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
-  identifier::User user(value.data());
-  message::set_definer(statement->schema_message, user);
-}
-
 void buildSchemaDefiner(LEX *lex, const identifier::User &user)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::set_definer(statement->schema_message, user);
 }
 
 void buildSchemaOption(LEX *lex, const char *key, uint64_t value)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
   opt->set_name(key);
   opt->set_state(boost::lexical_cast<std::string>(value));
@@ -654,7 +647,7 @@
 
 void buildReplicationOption(LEX *lex, bool arg)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::set_is_replicated(statement->schema_message, arg);
 }
 

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2011-10-18 12:33:04 +0000
+++ drizzled/parser.h	2011-10-19 17:58:50 +0000
@@ -117,7 +117,7 @@
 void my_parse_error(Lex_input_stream*);
 void my_parse_error(const char*);
 bool check_reserved_words(str_ref);
-void errorOn(drizzled::Session*, const char *s);
+void errorOn(Session*, const char *s);
 
 
 bool buildOrderBy(LEX*);
@@ -125,8 +125,7 @@
 void buildEngineOption(LEX*, const char *key, uint64_t value);
 void buildSchemaOption(LEX*, const char *key, str_ref value);
 void buildSchemaOption(LEX*, const char *key, uint64_t value);
-void buildSchemaDefiner(LEX*, const lex_string_t &value);
-void buildSchemaDefiner(LEX*, const identifier::User &user);
+void buildSchemaDefiner(LEX*, const identifier::User&);
 bool checkFieldIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name);
 
 Item *buildIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name, const lex_string_t &field_name);
@@ -138,19 +137,19 @@
 
 bool buildCollation(LEX*, const charset_info_st *arg);
 void buildKey(LEX*, Key::Keytype type_par, const lex_string_t &name_arg);
-void buildForeignKey(LEX*, const lex_string_t &name_arg, drizzled::Table_ident *table);
+void buildForeignKey(LEX*, const lex_string_t &name_arg, Table_ident *table);
 
-drizzled::enum_field_types buildIntegerColumn(LEX*, drizzled::enum_field_types final_type, const bool is_unsigned);
-drizzled::enum_field_types buildSerialColumn(LEX*);
-drizzled::enum_field_types buildVarcharColumn(LEX*, const char *length);
-drizzled::enum_field_types buildVarbinaryColumn(LEX*, const char *length);
-drizzled::enum_field_types buildBlobColumn(LEX*);
-drizzled::enum_field_types buildBooleanColumn(LEX*);
-drizzled::enum_field_types buildUuidColumn(LEX*);
-drizzled::enum_field_types buildIPv6Column(LEX*);
-drizzled::enum_field_types buildDoubleColumn(LEX*);
-drizzled::enum_field_types buildTimestampColumn(LEX*, const char *length);
-drizzled::enum_field_types buildDecimalColumn(LEX*);
+enum_field_types buildIntegerColumn(LEX*, enum_field_types final_type, const bool is_unsigned);
+enum_field_types buildSerialColumn(LEX*);
+enum_field_types buildVarcharColumn(LEX*, const char *length);
+enum_field_types buildVarbinaryColumn(LEX*, const char *length);
+enum_field_types buildBlobColumn(LEX*);
+enum_field_types buildBooleanColumn(LEX*);
+enum_field_types buildUuidColumn(LEX*);
+enum_field_types buildIPv6Column(LEX*);
+enum_field_types buildDoubleColumn(LEX*);
+enum_field_types buildTimestampColumn(LEX*, const char *length);
+enum_field_types buildDecimalColumn(LEX*);
 
 void buildKeyOnColumn(LEX*);
 void buildAutoOnColumn(LEX*);

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-10-19 16:40:11 +0000
+++ drizzled/sql_yacc.yy	2011-10-19 17:58:50 +0000
@@ -1013,7 +1013,7 @@
           }
         | DEFINER TEXT_STRING_sys
           {
-            parser::buildSchemaDefiner(&Lex, $2);
+            parser::buildSchemaDefiner(&Lex, identifier::User($2));
           }
         | DEFINER CURRENT_USER optional_braces
           {
@@ -1080,8 +1080,7 @@
           }
         | DEFINER TEXT_STRING_sys
           {
-	    drizzled::identifier::User user($2.data());
-            message::set_definer(*Lex.table(), user);
+            message::set_definer(*Lex.table(), identifier::User($2));
           }
         | DEFINER CURRENT_USER optional_braces
           {

=== modified file 'drizzled/util/data_ref.h'
--- drizzled/util/data_ref.h	2011-10-18 11:48:44 +0000
+++ drizzled/util/data_ref.h	2011-10-19 17:58:50 +0000
@@ -57,8 +57,7 @@
 
   void clear()
   {
-    begin_ = NULL;
-    end_ = NULL;
+    begin_ = end_ = reinterpret_cast<T>("");
   }
 
   void assign(const void* b, const void* e)

